/**
 * compute the edit distance between two strings
 * @author Widmann Annekathrin und Riester Markus
 * Date: Oct 20, 2003
 */
package albi.align;

/** 
 * compute the edit distance between two sequences
 */
public class EditDistance {
	private static int[][] D; 
	

    static public int compute (String seq1,String seq2)
    {
		// please implement the edit distance computation here!
			
		D = new int[seq1.length()+1][seq2.length()+1];
		for (int i = 0; i <= seq1.length(); i++) D[i][0] = i;
		for (int j = 0; j <= seq2.length(); j++) D[0][j] = j;
		
		for (int i = 1; i < seq1.length() + 1; i++)
			for (int j = 1; j <  seq2.length() + 1;j++) {
				int t = 1;
				if (seq1.charAt(i - 1) == seq2.charAt(j - 1)) t = 0;	
				D[i][j] = min( D[i][j-1]+1, D[i-1][j]+1,  D[i-1][j-1] + t);
				
			}
			
		/*for (int i = 0; i <= seq1.length(); i++) {
			System.out.print("\n");
		
					for (int j = 0; j <= seq2.length();j++) {
						System.out.print(D[i][j]);
					}
		}*/						
		return D[seq1.length()][seq2.length()];
    }
    
	/**
		* returns the minimum of v1, v2 and v3
		* @param v1
		* @param v2
		* @param v3
		* @return
		*/
	private static int min(int v1, int v2, int v3) 
    {
    	int result = Math.min(v1, v2);
    	result = Math.min(result, v3);
    	return result;
    }
    
}
