/**
 * report the edit distance between two strings
 * @author Daniel Huson
 * Date: Oct 20, 2003
 */
package albi.progs;

import albi.io.FastA;
import albi.align.EditDistance;

import java.io.FileReader;
import java.io.File;

/** 
 * report the edit distance between two sequences
 */
public class RunEditDistance {

    /**
     * reports the edit distance between two sequences
     * @param args commandline arguments: file1 file2
     * @throws Exception
     */
    static public void main (String[] args) throws Exception
    {
        if(args.length!=2)
            throw new Exception("Usage: ReportEditDistance infile1 infile2");

        FastA fasta1=new FastA();
        fasta1.read(new FileReader(new File(args[0])));

        FastA fasta2=new FastA();
        fasta2.read(new FileReader(new File(args[1])));

        System.out.println("Edit distance: "+EditDistance.compute(fasta1.getFirstSequence(),
                fasta2.getFirstSequence()));
    }
}
